#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 PaleVioletRed
#property indicator_color2 Violet
#property indicator_color3 Red
#property indicator_color4 DeepSkyBlue
#property indicator_color5 Blue
#property indicator_color6 Turquoise
#property indicator_color7 Pink
#property indicator_color8 Gold
#property indicator_level1    0
#property indicator_level2  100
#property indicator_level3 -100

extern string TimeFrame     = "Current time frame";
extern int    MA_Period     = 5;
extern int    MA_Method     = MODE_LWMA;
extern int    CCI_Period    = 14;
extern int    applied_price = 0; 
extern string ForSymbol1    = "";
extern string ForSymbol2    = "";
extern string ForSymbol3    = "";
extern string ForSymbol4    = "";
extern string ForSymbol5    = "";
extern string ForSymbol6    = "";
extern string ForSymbol7    = "";
extern string ForSymbol8    = "";

double CCI_idx1[];
double CCI_idx2[];
double CCI_idx3[];
double CCI_idx4[];
double CCI_idx5[];
double CCI_idx6[];
double CCI_idx7[];
double CCI_idt[];
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0,CCI_idx1);
   SetIndexBuffer(1,CCI_idx2);
   SetIndexBuffer(2,CCI_idx3);
   SetIndexBuffer(3,CCI_idx4);
   SetIndexBuffer(4,CCI_idx5);
   SetIndexBuffer(5,CCI_idx6);
   SetIndexBuffer(6,CCI_idx7);
   SetIndexBuffer(7,CCI_idt);
      if (ForSymbol1=="") ForSymbol1 = Symbol();
      if (ForSymbol2=="") ForSymbol2 = Symbol();
      if (ForSymbol3=="") ForSymbol3 = Symbol();
      if (ForSymbol4=="") ForSymbol4 = Symbol();
      if (ForSymbol5=="") ForSymbol5 = Symbol();
      if (ForSymbol6=="") ForSymbol6 = Symbol();
      if (ForSymbol7=="") ForSymbol7 = Symbol();
      if (ForSymbol8=="") ForSymbol8 = Symbol();
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      IndicatorShortName(timeFrameToString(timeFrame)+" smoothed CCI");
   return(0);
}
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
  {
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { CCI_idx1[0] = limit+1; return(0); }
         if (!calculateValue)
         {
            checkSymbol(limit,ForSymbol1,CCI_idx1);
            checkSymbol(limit,ForSymbol2,CCI_idx2);
            checkSymbol(limit,ForSymbol3,CCI_idx3);
            checkSymbol(limit,ForSymbol4,CCI_idx4);
            checkSymbol(limit,ForSymbol5,CCI_idx5);
            checkSymbol(limit,ForSymbol6,CCI_idx6);
            checkSymbol(limit,ForSymbol7,CCI_idx7);
            checkSymbol(limit,ForSymbol8,CCI_idt);
            return(0);
         }   
         
   for(i=limit;i>=0;i--) CCI_idt[i]  = iCCI(NULL,0,CCI_Period,applied_price,i);
   for(i=limit;i>=0;i--) CCI_idx1[i] = iMAOnArray(CCI_idt,0,MA_Period,0,MA_Method,i); 
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void checkSymbol(int limit, string ForSymbol, double& buffer[])
{
   limit = MathMax(limit,MathMin(Bars-1,iCustom(ForSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (int i=limit; i>=0; i--)
   {
      int y = iBarShift(ForSymbol,timeFrame,Time[i]);
       buffer[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue",MA_Period,MA_Method,CCI_Period,applied_price,"",0,y);
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("M" + DoubleToStr(timeFrame,0));
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}